/*
 * Filename:	include/cameo/ipv4_arp.h	
 * Author:	arrow <jianzhang@nettech-global.com>
 * Created at:	Sun Aug 23 18:49:23 2009
 ******************************************************************************/
#ifndef _CAMEO_IPV4_ARP_H
#define _CAMEO_IPV4_ARP_H

#include <linux/types.h>
#include <net/neighbour.h>
#include <linux/skbuff.h>

/* use a macro for unify the v2 with others */
#ifndef _UNIFY_IPV4_ARP_SHOW
#define _UNIFY_IPV4_ARP_SHOW

#ifdef CONFIG_V2ShowArp
int neigh_update_with_realdev(struct neighbour *neigh, const u8 *lladdr, u8 new,
			      u32 flags, struct sk_buff *skb, struct net_device *dev);
#else
#    define neigh_update_with_realdev(neigh, lladdr, new, flags, skb, dev) \
				      ({neigh_update(neigh, lladdr, new, flags);})
#endif
#endif

#ifdef CONFIG_RP_IPMAC_FILTER
int arp_ip_mac_filter(struct neigh_table *tbl, void *ip, u8 *ha, struct net_device *dev);
#else
#define arp_ip_mac_filter(tbl, ip, ha, dev)  \
		do {} while(0);
#endif

#endif

